var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_helper_plugin_utils = require("@babel/helper-plugin-utils");
var import_sourceMap = __toESM(require("./sourceMap"));
var import_path = require("path");
const sourceMapProperty = "sourceMap";
var stdin_default = (0, import_helper_plugin_utils.declare)((api) => {
  const { types: t } = api;
  api.assertVersion(7);
  let readyImport = false;
  return {
    name: "@styils/babel-plugin",
    manipulateOptions(_, parserOpts) {
      const { plugins } = parserOpts;
      plugins.forEach((plugin, index) => {
        if (plugin === "jsx")
          plugins.splice(index, 1);
      });
      plugins.forEach((plugin, index) => {
        const name = Array.isArray(plugin) ? plugin[0] : plugin;
        if (name === "flow")
          plugins.splice(index, 1);
      });
      plugins.push("jsx", "typescript", "classProperties");
    },
    visitor: {
      Program: {
        enter(_, state) {
          if (!state.opts.importPaths) {
            state.opts.importPaths = /@styils\/(react|solid)/;
          }
          state.opts.identifier = {
            styled: "styled",
            createGlobal: "createGlobal",
            ...state.opts.identifier ?? {}
          };
        }
      },
      ImportDeclaration(path, state) {
        const { importPaths } = state.opts;
        if (importPaths) {
          const isImport = typeof importPaths === "string" ? importPaths === path.node.source.value : importPaths.test(path.node.source.value);
          const ext = (0, import_path.extname)(path.node.source.value);
          if (ext !== ".js" && ext !== ".ts" && ext && isImport) {
            console.log(`styils-plugin wrong match: ${path.node.source.value}`);
          }
          if (isImport) {
            readyImport = path.node.specifiers.some((childNode) => {
              return state.opts.identifier[childNode.local.name];
            });
          }
        }
      },
      CallExpression(path, state) {
        const sourceFileName = state.file.opts.filename ?? state.file.opts.sourceFileName ?? state.opts.sourceFileName;
        const sourceRoot = state.file.opts.sourceRoot ?? state.opts.sourceRoot ?? "";
        if (!sourceFileName) {
          throw new Error("To compile using api, you need to pass in `sourceFileName`");
        }
        if (readyImport && t.isIdentifier(path.node.callee) && state.opts.identifier && state.opts.identifier[path.node.callee.name] && path.node.loc) {
          let parent = null;
          if (path.node.callee.name === state.opts.identifier.styled) {
            parent = path.findParent((parent2) => parent2.isVariableDeclaration());
          } else if (path.node.callee.name === state.opts.identifier.createGlobal) {
            parent = path.findParent((parent2) => parent2.isExpressionStatement());
          }
          if (parent) {
            const sourceMapNode = t.logicalExpression(
              "&&",
              t.binaryExpression(
                "!==",
                t.memberExpression(
                  t.memberExpression(t.identifier("process"), t.identifier("env")),
                  t.identifier("NODE_ENV")
                ),
                t.stringLiteral("production")
              ),
              t.assignmentExpression(
                "=",
                t.memberExpression(
                  t.identifier(path.node.callee.name),
                  t.identifier(sourceMapProperty)
                ),
                t.stringLiteral(
                  (0, import_sourceMap.default)(path.node.loc.start, {
                    sourceFileName,
                    sourceRoot,
                    code: state.file.code
                  })
                )
              )
            );
            parent.insertBefore(sourceMapNode);
          }
        }
      }
    }
  };
});
