import { SourceMapGenerator } from "source-map";
import convert from "convert-source-map";
function addSourceMaps(offset, state) {
  const { code } = state;
  const generator = new SourceMapGenerator({
    file: state.sourceFileName,
    sourceRoot: state.sourceRoot
  });
  generator.setSourceContent(state.sourceFileName, code);
  generator.addMapping({
    generated: {
      line: 1,
      column: 0
    },
    source: state.sourceFileName,
    original: offset
  });
  return convert.fromObject(generator).toComment({ multiline: true });
}
export {
  addSourceMaps as default
};
